<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageDailyProductType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageDailyProductType extends AbstractStructArrayBase
{
    /**
     * The ProductTypes
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageDailyProductType[]
     */
    public $ProductTypes;
    /**
     * Constructor method for ArrayOfJP_PackageDailyProductType
     * @uses ArrayOfJP_PackageDailyProductType::setProductTypes()
     * @param \StructType\JP_PackageDailyProductType[] $productTypes
     */
    public function __construct(array $productTypes = array())
    {
        $this
            ->setProductTypes($productTypes);
    }
    /**
     * Get ProductTypes value
     * @return \StructType\JP_PackageDailyProductType[]|null
     */
    public function getProductTypes()
    {
        return $this->ProductTypes;
    }
    /**
     * This method is responsible for validating the values passed to the setProductTypes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductTypes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductTypesForArrayConstraintsFromSetProductTypes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PackageDailyProductTypeProductTypesItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageDailyProductTypeProductTypesItem instanceof \StructType\JP_PackageDailyProductType) {
                $invalidValues[] = is_object($arrayOfJP_PackageDailyProductTypeProductTypesItem) ? get_class($arrayOfJP_PackageDailyProductTypeProductTypesItem) : sprintf('%s(%s)', gettype($arrayOfJP_PackageDailyProductTypeProductTypesItem), var_export($arrayOfJP_PackageDailyProductTypeProductTypesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProductTypes property can only contain items of type \StructType\JP_PackageDailyProductType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductTypes value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageDailyProductType[] $productTypes
     * @return \ArrayType\ArrayOfJP_PackageDailyProductType
     */
    public function setProductTypes(array $productTypes = array())
    {
        // validation for constraint: array
        if ('' !== ($productTypesArrayErrorMessage = self::validateProductTypesForArrayConstraintsFromSetProductTypes($productTypes))) {
            throw new \InvalidArgumentException($productTypesArrayErrorMessage, __LINE__);
        }
        $this->ProductTypes = $productTypes;
        return $this;
    }
    /**
     * Add item to ProductTypes value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageDailyProductType $item
     * @return \ArrayType\ArrayOfJP_PackageDailyProductType
     */
    public function addToProductTypes(\StructType\JP_PackageDailyProductType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageDailyProductType) {
            throw new \InvalidArgumentException(sprintf('The ProductTypes property can only contain items of type \StructType\JP_PackageDailyProductType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProductTypes[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageDailyProductType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageDailyProductType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageDailyProductType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageDailyProductType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageDailyProductType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductTypes
     */
    public function getAttributeName()
    {
        return 'ProductTypes';
    }
}
